<template>
    <div class="wishlist spacing-top-mobile">
        <v-row class="justify-center">
            <v-col md="10">
                <h2 class="text-center">{{ $t('appBar.menu.WISHLIST') }}</h2>
                <!-- PRODUCTS -->
                <v-row v-if="wishlist.items">
                    <v-col v-if="wishlist.items.length === 0">
                        <p class="font-metropolis-regular">
                            {{ $t('common.noWishlist') }}
                        </p>
                    </v-col>

                    <v-col
                        v-for="(p, prod) in wishlist.items"
                        v-else
                        :key="'product-' + prod"
                        cols="6"
                        md="3"
                        class="mb-10"
                    >
                        <div class="product-container mb-5">
                            <nuxt-link :to="'/products/' + p.product.slug">
                                <div class="hover-bg">
                                    <img
                                        v-if="p.product.images.length > 1"
                                        :src="p.product.images[1].url"
                                        :alt="p.product.name"
                                        class="image"
                                    />
                                </div>
                            </nuxt-link>
                            <div class="product-wish">
                                <v-btn
                                    text
                                    @click="removeFromWishlist(p.product.id)"
                                >
                                    <v-icon
                                        class="heart-icon-default"
                                        v-html="checkWishlist(p.product.id)"
                                    ></v-icon>
                                </v-btn>
                            </div>
                            <nuxt-link :to="'/products/' + p.product.slug">
                                <img
                                    :src="p.product.images[0].url"
                                    :alt="p.product.name"
                                    class="image"
                                />
                            </nuxt-link>
                        </div>
                        <p class="product-title-text mb-1">
                            {{ p.product.name }}
                        </p>
                        <p class="product-desc-text">
                            <!-- {{ p.size }}/{{ p.collection }}/ -->
                            {{ currencyName }}
                            {{ p.product.pricing[currency].price }}
                        </p>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>

        <!-- PAGINATION -->
        <v-row v-if="length > 1">
            <v-col>
                <v-pagination v-model="page" :length="length" color="black" />
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            title: this.$t('appBar.menu.WISHLIST'),
        }
    },
    computed: {
        ...mapGetters({
            currency: 'currency/getCurrency',
            currencyName: 'currency/getCurrencyName',
            wishlist: 'wishlist/getWishlist',
            checkWishlist: 'wishlist/checkWishlist',
        }),
    },
})
export default class Browse extends Vue {
    // Data
    totalProduct: Number = 0
    page: number = 1
    length: number = 1
    message: any = null
    color: String = ''
    icon: String = ''

    // Methods
    @Debounce(500)
    async removeFromWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.wishlist.deleteWishlist(id)

            if (deleteResponse) {
                this.$store.dispatch('wishlist/removeFromWishlist', id)
                this.message = this.$t('notification.wishlist.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    addToBox(product: {}) {
        this.$store.dispatch('cart/addToCart', product)
        const val = {
            text: this.$t('notification.cart.added'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }
}
</script>
